import { isChain, chainToPlatform, } from "@wormhole-foundation/sdk-base";
const nativeFactory = new Map();
export function registerNative(platform, ctr) {
    if (nativeFactory.has(platform)) {
        console.error("Native address type for platform %s has already registered", platform);
        //throw new Error(`Native address type for platform ${platform} has already registered`);
        return;
    }
    nativeFactory.set(platform, ctr);
}
export function nativeIsRegistered(chainOrPlatform) {
    const platform = isChain(chainOrPlatform)
        ? chainToPlatform.get(chainOrPlatform)
        : chainOrPlatform;
    return nativeFactory.has(platform);
}
export function toNative(chainOrPlatform, ua) {
    const platform = isChain(chainOrPlatform)
        ? chainToPlatform.get(chainOrPlatform)
        : chainOrPlatform;
    const nativeCtr = nativeFactory.get(platform);
    if (!nativeCtr)
        throw new Error(`No native address type registered for platform ${platform}`);
    return new nativeCtr(ua);
}
//# sourceMappingURL=address.js.map